buildIndexStr=function(dial_plan, called_nbr) {
    return hex_md5("dialPlan"+dial_plan+"calledNbr"+called_nbr);
};

getAnaCldNbrListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.dialPlan, ev.calledNbr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        $("#"+indexStr).append("<td>"+ev.dialPlan+"</td>");
        $("#"+indexStr).append("<td>"+ev.calledNbr+"</td>");
        $("#"+indexStr).append("<td>"+ev.description+"</td>");
        $("#"+indexStr).append("<td>"+translateRtType(ev.routeType)+"</td>");
        
        if( null != ev.clrRefineID )
        {
            $("#"+indexStr).append("<td>"+ev.clrRefineID+"</td>");
        }
        else
        {
            $("#"+indexStr).append("<td></td>");
        }
        
        if( null != ev.callLevel )
        {
            $("#"+indexStr).append("<td>"+ev.callLevel+"</td>");
        }
        else
        {
            $("#"+indexStr).append("<td></td>");
        }
        
        if( null != ev.maxDuration )
        {
            $("#"+indexStr).append("<td>"+ev.maxDuration+"</td>");
        }
        else
        {
            $("#"+indexStr).append("<td></td>");
        }
        
        $("#"+indexStr).append("<td>"+addBtnEdit(`editAnaCalledNbr('${ev.dialPlan}','${ev.calledNbr}')`)
                                +addBtnDel(`delAnaCalledNbr('${ev.dialPlan}','${ev.calledNbr}')`)+"</td>");
        
    });
    
};

getAnaCldNbrList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/anacldnbr/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getAnaCldNbrListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getAnaCldNbrList);
};

gotoNextList=function() {
    pageNext(getAnaCldNbrList);
};

getAnaCldNbrDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#dialPlan").val(ev.dialPlan);
        $("#calledNbr").val(ev.calledNbr);
        $("#description").val(ev.description);
        $("#rtType").val(ev.routeType);
        rtTypeChanged();
        
        $("#servID").val(ev.servID);
        $("#extLine").val(ev.extLine);
        $("#rtGroupID").val(ev.rtGroupID);
                
        if( null != ev.changeInd && 1==ev.changeInd )
        {
            setInputChecked("changeInd");
        }
        else
        {
            removeInputChecked("changeInd");
        }
        
        if( null != ev.tranID )
        {
            $("#tranID").val(ev.tranID);
        }
        
        if( null != ev.reAnaInd && 1==ev.reAnaInd )
        {
            setInputChecked("reAnaInd");
        }
        else
        {
            removeInputChecked("reAnaInd");
        }

        editBoxSetIntValue('clrRefineID', ev.clrRefineID);
        editBoxSetIntValue('maxDuration', ev.maxDuration);
        $("#callLevel").val(ev.callLevel);        
    });
};

getAnaCldNbrDetail=function(dial_plan, called_nbr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("dialPlan", dial_plan)+",";;
    jsonStr += jsonEncodeString("calledNbr", called_nbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/anacldnbr/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getAnaCldNbrDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateAnaCldNbrDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeString("dialPlan", $("#dialPlan").val())+",";
    jsonStr += jsonEncodeString("calledNbr", $("#calledNbr").val())+",";
    
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeNumber("routeType", $("#rtType").val())+",";
    
    jsonStr += jsonEncodeNumber("servID", $("#servID").val())+",";
    jsonStr += jsonEncodeString("extLine", $("#extLine").val())+",";
    jsonStr += jsonEncodeNumber("rtGroupID", $("#rtGroupID").val())+",";
    
    if(inputHasChecked("changeInd"))
    {
        jsonStr += jsonEncodeNumber("changeInd", 1)+",";
    }
    
    jsonStr += jsonEncodeNumber("tranID", $("#tranID").val())+",";
    if(inputHasChecked("reAnaInd"))
    {
        jsonStr += jsonEncodeNumber("reAnaInd", 1)+",";
    }
    
    jsonStr += jsonEncodeNumber("clrRefineID", editBoxIntValue('clrRefineID'))+",";
    jsonStr += jsonEncodeNumber("maxDuration", editBoxIntValue('maxDuration'))+",";
    jsonStr += jsonEncodeNumber("callLevel", $("#callLevel").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/anacldnbr/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiAnaCalledNbr.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiAnaCalledNbr.html");
        }
    });
};


delAnaCalledNbr=function(dial_plan, called_nbr) {
    var indexStr = buildIndexStr(dial_plan, called_nbr);
    var jsonStr = "{";
    jsonStr += jsonEncodeString("dialPlan", dial_plan)+",";
    jsonStr += jsonEncodeString("calledNbr", called_nbr);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/anacldnbr/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiAnaCalledNbrDlg.html");
};

editAnaCalledNbr=function(dial_plan, called_nbr) {
    var dataPost = "calledNbr="+encodeURIComponent(called_nbr);   
    dataPost += "&dialPlan="+encodeURIComponent(dial_plan); 
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiAnaCalledNbrDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiAnaCalledNbr.html");
};

function hideRtExtlineItems() {
    $("#rtExtLineItems").hide();
}

function showRtExtlineItems()
{
    $("#rtExtLineItems").show();
}

function hideRtSIPTrunkItems()
{
    $("#rtSIPTrunkItems").hide();
}
function showRtSIPTrunkItems()
{
    $("#rtSIPTrunkItems").show();
}

function hideRtGroupItems()
{
    $("#rtGroupItems").hide();
}
function showRtGroupItems()
{
    $("#rtGroupItems").show();
}


function hideRtItems()
{
    hideRtExtlineItems();
    hideRtSIPTrunkItems();
    hideRtGroupItems();
}

function showRtItems(currRtType)
{
    hideRtItems();

    switch(parseInt(currRtType))
    {
        case 1: // external line
            showRtExtlineItems();
            break;
            
        case 2: // sip trunk
            showRtSIPTrunkItems();
            break
            
        case 6: // routing group
            showRtGroupItems();
            break
            
        default:                    
            break;
    }
}

function rtTypeChanged()
{
    var currRtType = $("#rtType").val();
    
    showRtItems(currRtType);
}