
getDisaAccListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = ev.account;
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.account+"</td>");
        $("#"+indexStr).append("<td>"+ev.ext+"</td>");
        
        $("#"+indexStr).append("<td>"+addBtnEdit(`editDisaAcc('${ev.account}')`)
                                       +addBtnDel(`delDisaAcc('${ev.account}')`)+"</td>");   
    });
    
};

getDisaAccList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/disaacc/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getDisaAccListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getDisaAccList);
};

gotoNextList=function() {
    pageNext(getDisaAccList);
};

getDisaAccDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#account").val(ev.account);
        $("#pwd").val(ev.pwd);
        $("#ext").val(ev.ext);
    });
};

getDisaAccDetail=function(account) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("account", account);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/disaacc/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getDisaAccDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateDisaAccDetail=function() {
    var jsonStr = "{";
            
    jsonStr += jsonEncodeString("account", $("#account").val())+",";
    jsonStr += jsonEncodeString("pwd", $("#pwd").val())+",";
    jsonStr += jsonEncodeString("ext", $("#ext").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/disaacc/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiDisaAcc.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiDisaAcc.html");
        }
    });
};

delDisaAcc=function(account) {    
    var jsonStr = "{";
    jsonStr += jsonEncodeString("account", account)
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/disaacc/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+account).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiDisaAccDlg.html");
};

editDisaAcc=function(account) {
    var dataPost = "account="+encodeURIComponent(account);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiDisaAccDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiDisaAcc.html");
};
